<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Error Handling in CarbonPHP</h1>

		<p>CarbonPHP has built in functions for error reporting that you can use in your application.  CarbonPHP
		also has an error logging class that allows you to log debugging and error messages to a log file.</p>

		<p><i>Note</i>: by default CarbonPHP will display all PHP errors.  You may wish to change this behaviour
		once you make your application live.  You can change this by changing the parameter of the
		<b>error_reporting()</b> function in the <b>index.php</b>.  Disabling PHPs error reporting will not stop
		log files being written by CarbonPHP.</p>

		<p>Unlike the other libraries in CarbonPHP, the error functions are just simple procedural interfaces.  They
		are globally available throughout CarbonPHP.  This allows error messages to be triggered without worrying
		about the scope of the class and methods.</p>
	</div>

	<div class="content">
		<h1>display_error('<i>message</i>');</h1>

		<p>This function will display a generic error using the message passed as a parameter using the template
		<b>application/errors/error.php</b> file.</p>
	</div>

	<div class="content">
		<h1>display_not_found('<i>page</i>');</h1>

		<p>This function will display a 404 page not found error message using the template file specified or it will
		display the template <b>application/errors/error_404.php</b> file.</p>
	</div>

	<div class="content">
		<h1>log_message('<i>level</i>', '<i>message</i>');</h1>

		<p>This function lets you write an error message to a log file.  You must supply one of three error levels in
		the first parameter.  The error message will be the second parameter.</p>

		<div class="example">
			if ($some_var != true)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;log_message('error', 'Some variable is not equal to true.');<br />
			&#125;<br />
			else<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;log_message('debug', 'Some variable is equal to true.');<br />
			&#125;<br />
			<br />
			log_message('info', 'Some variable is used to provide a value.');
		</div>

		<p>There are three types of error message.</p>

		<ul>
			<li><b>error</b> - these are actual errors, such as a PHP error or user error.</li>
			<li><b>debug</b> - these are messages that will assist with the debugging of the application.</li>
			<li><b>info</b> - these are low priority messages that simply just give information.</li>
		</ul>

		<p><i>Note</i>: in order for CarbonPHP to log to files, the <b>logs</b> folder must be writable, and you
		must set a threshold for logging in the configuration file.  For example if you wish to only log error
		messages, and not the other two error types.  If you set the threshold to zero, logging will be disabled.</p>
	</div>
</body>

</html>
